<?php
/*
Plugin Name: Facebook Embedded Posts
Plugin URI: http://www.torbenleuschner.de/blog/865/facebook-posts-wordpress-plugin/
Description: Add Facebook posts to your Wordpress blog. You can embed a post via shortcode [fb-post href=""] in your articles or pages.
Author: Torben Leuschner
Author URI: http://www.torbenleuschner.de
Version: 1.0
*/

function fb_embedded_register_shortcodes()
{
    add_shortcode('fb-post', 'fb_embedded_post');
}

function fb_embedded_post($a)
{
    if(!$a['href'])
        return '<div style="color:red;">FB Post: Shortcode parameter "href" is required</div>';

    if(strpos($a['href'], 'facebook.com') === false)
        return '<div style="color:red;">FB Post: Shortcode parameter "href" must contain a valid Facebook URL</div>';

    return '
    <div id="fb-root"></div>
    <script>(function(d, s, id) { var js, fjs = d.getElementsByTagName(s)[0]; if (d.getElementById(id)) return; js = d.createElement(s); js.id = id; js.src = "//connect.facebook.net/'.fb_embedded_get_language().'/all.js#xfbml=1"; fjs.parentNode.insertBefore(js, fjs); }(document, \'script\', \'facebook-jssdk\'));</script>
    <fb:post href="'.$a['href'].'"></fb:post>';
}

function fb_embedded_get_language()
{
    $lang = get_bloginfo('language');
    $codes = explode('-', $lang);

    return $codes[0].'_'.strtoupper($codes[1]);
}


add_action( 'init', 'fb_embedded_register_shortcodes');
?>